diff -Naur newlib-1.20.0.orig/newlib/libc/include/complex.h newlib-1.20.0/newlib/libc/include/complex.h
--- newlib-1.20.0.orig/newlib/libc/include/complex.h	2010-10-08 12:35:13.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/complex.h	2012-03-28 10:11:12.248138513 +0200
@@ -77,7 +77,7 @@
 
 /* 7.3.8 Power and absolute-value functions */
 /* 7.3.8.1 The cabs functions */
-/*#ifndef __LIBM0_SOURCE__
+/*#ifndef __LIBM0_SOURCE__ */
 /* avoid conflict with historical cabs(struct complex) */
 /* double cabs(double complex) __RENAME(__c99_cabs);
    float cabsf(float complex) __RENAME(__c99_cabsf);
diff -Naur newlib-1.20.0.orig/newlib/libc/include/inttypes.h newlib-1.20.0/newlib/libc/include/inttypes.h
--- newlib-1.20.0.orig/newlib/libc/include/inttypes.h	2009-01-19 23:02:06.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/inttypes.h	2012-03-28 10:11:12.249138529 +0200
@@ -17,6 +17,117 @@
 #define __need_wchar_t
 #include <stddef.h>
 
+/* _GCC_STDINT_H is defined by GCC's stdint.h */
+#ifdef _GCC_STDINT_H
+
+/* Provide defines having been provided by newlib's stdint.h, 
+ * but not provided by GCC's stdint.h
+ */
+
+/* FIXME: We should be using a more general approach and not be using 
+ * a cascade of __<arch>__ defines
+ */
+
+#ifdef __arm__
+#define __have_long32		1
+#define __have_longlong64	1
+#ifdef __ARM_EABI__
+#define __have_int_intptr	1
+#else
+#define __have_long_intptr	1
+#endif
+#endif
+
+#ifdef __AVR__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_int_intptr	1
+#endif
+
+#ifdef __bfin__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_long_intptr	1
+#endif
+
+#ifdef __h8300__
+#define __have_long32		1
+#define __have_longlong64	1
+#if defined(__H8300H__) || defined(__H8300S__) || defined(__H8300SX__)
+#define __have_long_intptr	1
+#else
+#define __have_int_intptr	1
+#endif
+#endif
+
+#ifdef __i386__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_long_intptr	1
+#endif
+
+#ifdef __lm32__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_int_intptr	1
+#endif
+
+#ifdef __m32c__
+#define __have_long32		1
+#define __have_longlong64	1
+#ifdef __m32cm_cpu__
+#define __have_long_intptr	1
+#else
+#define __have_int_intptr	1
+#endif
+#endif
+
+#ifdef __m32r__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_long_intptr	1
+#endif
+
+#ifdef __m68k__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_long_intptr	1
+#endif
+
+#ifdef __mips__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_int_intptr	1
+#endif
+
+#ifdef __PPC__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_int_intptr	1
+#endif
+
+#ifdef __sh__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_int_intptr	1
+#endif
+
+#ifdef __sparc__
+#define __have_long32		1
+#define __have_longlong64	1
+#define __have_int_intptr	1
+#endif
+
+#if defined(__INT64_TYPE__)
+#define __int64_t_defined 1
+#endif
+
+#if !defined(__have_int_intptr) && !defined(__have_long_intptr)
+#error cannot determine type of intptr_t
+#endif
+
+#endif /* _GCC_STDINT_H */
+
 #define __STRINGIFY(a) #a
 
 /* 8-bit types */
@@ -242,15 +353,23 @@
 #define SCNxMAX		__SCNMAX(x)
 
 /* ptr types */
-#if __have_long64
+#if __have_long_intptr
 #define __PRIPTR(x) __STRINGIFY(l##x)
 #define __SCNPTR(x) __STRINGIFY(l##x)
-#elif __have_longlong64
-#define __PRIPTR(x) __STRINGIFY(ll##x)
-#define __SCNPTR(x) __STRINGIFY(ll##x)
-#else
+#elif __have_int_intptr
 #define __PRIPTR(x) __STRINGIFY(x)
 #define __SCNPTR(x) __STRINGIFY(x)
+#elif INTPTR_MAX == INT64_MAX
+#define __PRIPTR(x) __PRI64(x)
+#define __SCNPTR(x) __SCN64(x)
+#elif INTPTR_MAX == INT32_MAX
+#define __PRIPTR(x) __PRI32(x)
+#define __SCNPTR(x) __SCN32(x)
+#elif INTPTR_MAX == INT16_MAX
+#define __PRIPTR(x) __PRI16(x)
+#define __SCNPTR(x) __SCN16(x)
+#else
+#error cannot determine PRI*PTR
 #endif
 
 #define PRIdPTR		__PRIPTR(d)
diff -Naur newlib-1.20.0.orig/newlib/libc/include/machine/_default_types.h newlib-1.20.0/newlib/libc/include/machine/_default_types.h
--- newlib-1.20.0.orig/newlib/libc/include/machine/_default_types.h	2008-06-12 00:14:54.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/machine/_default_types.h	2012-03-28 10:11:12.249138529 +0200
@@ -54,14 +54,14 @@
 #endif
 #endif
 
-#if __EXP(INT_MAX) == 0x7fffffffL
-typedef signed int __int32_t;
-typedef unsigned int __uint32_t;
-#define ___int32_t_defined 1
-#elif __EXP(LONG_MAX) == 0x7fffffffL
+#if __EXP(LONG_MAX) == 0x7fffffffL
 typedef signed long __int32_t;
 typedef unsigned long __uint32_t;
 #define ___int32_t_defined 1
+#elif __EXP(INT_MAX) == 0x7fffffffL
+typedef signed int __int32_t;
+typedef unsigned int __uint32_t;
+#define ___int32_t_defined 1
 #elif __EXP(SHRT_MAX) == 0x7fffffffL
 typedef signed short __int32_t;
 typedef unsigned short __uint32_t;
diff -Naur newlib-1.20.0.orig/newlib/libc/include/machine/ieeefp.h newlib-1.20.0/newlib/libc/include/machine/ieeefp.h
--- newlib-1.20.0.orig/newlib/libc/include/machine/ieeefp.h	2011-11-29 07:33:48.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/machine/ieeefp.h	2012-03-28 10:11:12.249138529 +0200
@@ -69,6 +69,11 @@
 #endif
 #endif
 
+#ifdef __epiphany__
+#define __IEEE_LITTLE_ENDIAN
+#define Sudden_Underflow 1
+#endif
+
 #ifdef __hppa__
 #define __IEEE_BIG_ENDIAN
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/include/machine/setjmp-dj.h newlib-1.20.0/newlib/libc/include/machine/setjmp-dj.h
--- newlib-1.20.0.orig/newlib/libc/include/machine/setjmp-dj.h	2001-02-22 23:12:39.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/machine/setjmp-dj.h	2012-03-28 10:11:12.250138545 +0200
@@ -2,7 +2,7 @@
  * Copyright (C) 1991 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libc/include/machine/setjmp.h newlib-1.20.0/newlib/libc/include/machine/setjmp.h
--- newlib-1.20.0.orig/newlib/libc/include/machine/setjmp.h	2011-11-29 07:33:48.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/machine/setjmp.h	2012-03-28 10:11:12.250138545 +0200
@@ -25,6 +25,12 @@
 #define _JBLEN  40
 #endif
 
+#ifdef __epiphany__
+/* All callee preserved registers: r4-r10,fp, sp, lr,r15, r32-r39  */
+#define _JBTYPE long long
+#define _JBLEN 10
+#endif
+
 /* necv70 was 9 as well. */
 
 #if defined(__m68k__) || defined(__mc68000__)
diff -Naur newlib-1.20.0.orig/newlib/libc/include/signal.h newlib-1.20.0/newlib/libc/include/signal.h
--- newlib-1.20.0.orig/newlib/libc/include/signal.h	2011-05-04 13:26:21.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/signal.h	2012-03-28 10:11:12.254138607 +0200
@@ -7,10 +7,6 @@
 _BEGIN_STD_C
 
 typedef int	sig_atomic_t;		/* Atomic entity type (ANSI) */
-#ifndef _POSIX_SOURCE
-typedef _sig_func_ptr sig_t;		/* BSD naming */
-typedef _sig_func_ptr sighandler_t;	/* glibc naming */
-#endif /* !_POSIX_SOURCE */
 
 #define SIG_DFL ((_sig_func_ptr)0)	/* Default action */
 #define SIG_IGN ((_sig_func_ptr)1)	/* Ignore action */
diff -Naur newlib-1.20.0.orig/newlib/libc/include/stdint.h newlib-1.20.0/newlib/libc/include/stdint.h
--- newlib-1.20.0.orig/newlib/libc/include/stdint.h	2009-04-24 23:55:07.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/stdint.h	2012-03-28 10:11:12.255138622 +0200
@@ -33,7 +33,7 @@
 /* Check if "long" is 64bit or 32bit wide */
 #if __STDINT_EXP(LONG_MAX) > 0x7fffffff
 #define __have_long64 1
-#elif __STDINT_EXP(LONG_MAX) == 0x7fffffff && !defined(__SPU__)
+#elif __STDINT_EXP(LONG_MAX) == 0x7fffffff
 #define __have_long32 1
 #endif
 
@@ -49,14 +49,14 @@
 #define __int_least8_t_defined 1
 #endif
 
-#if __STDINT_EXP(SHRT_MAX) == 0x7fff
-typedef signed short int16_t;
-typedef unsigned short uint16_t;
-#define __int16_t_defined 1
-#elif __STDINT_EXP(INT_MAX) == 0x7fff
+#if __STDINT_EXP(INT_MAX) == 0x7fff
 typedef signed int int16_t;
 typedef unsigned int uint16_t;
 #define __int16_t_defined 1
+#elif __STDINT_EXP(SHRT_MAX) == 0x7fff
+typedef signed short int16_t;
+typedef unsigned short uint16_t;
+#define __int16_t_defined 1
 #elif __STDINT_EXP(SCHAR_MAX) == 0x7fff
 typedef signed char int16_t;
 typedef unsigned char uint16_t;
@@ -239,6 +239,29 @@
  * GCC doesn't provide an appropriate macro for [u]intptr_t
  * For now, use __PTRDIFF_TYPE__
  */
+#if defined(__SIZEOF_POINTER__)
+#if __SIZEOF_POINTER__ == 8
+  typedef int64_t intptr_t;
+  typedef uint64_t uintptr_t;
+#define INTPTR_MAX INT64_MAX
+#define INTPTR_MIN INT64_MIN
+#define UINTPTR_MAX UINT64_MAX
+#elif __SIZEOF_POINTER__ == 4
+  typedef int32_t intptr_t;
+  typedef uint32_t uintptr_t;
+#define INTPTR_MAX INT32_MAX
+#define INTPTR_MIN INT32_MIN
+#define UINTPTR_MAX UINT32_MAX
+#elif __SIZEOF_POINTER__ == 2
+  typedef int16_t intptr_t;
+  typedef uint16_t uintptr_t;
+#define INTPTR_MAX INT16_MAX
+#define INTPTR_MIN INT16_MIN
+#define UINTPTR_MAX UINT16_MAX
+#else
+#error cannot determine intptr_t
+#endif
+#else
 #if defined(__PTRDIFF_TYPE__)
 typedef signed __PTRDIFF_TYPE__ intptr_t;
 typedef unsigned __PTRDIFF_TYPE__ uintptr_t;
@@ -260,6 +283,7 @@
 #define INTPTR_MIN (-__STDINT_EXP(LONG_MAX) - 1)
 #define UINTPTR_MAX (__STDINT_EXP(LONG_MAX) * 2UL + 1)
 #endif
+#endif
 
 /* Limits of Specified-Width Integer Types */
 
@@ -408,6 +432,8 @@
 /* This must match size_t in stddef.h, currently long unsigned int */
 #ifdef __SIZE_MAX__
 #define SIZE_MAX __SIZE_MAX__
+#elif defined(__SIZEOF_SIZE_T__) && defined(__CHAR_BIT__)
+#define SIZE_MAX (((1UL << (__SIZEOF_SIZE_T__ * __CHAR_BIT__ - 1)) - 1) * 2 + 1)
 #else
 #define SIZE_MAX (__STDINT_EXP(LONG_MAX) * 2UL + 1)
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/include/stdio.h newlib-1.20.0/newlib/libc/include/stdio.h
--- newlib-1.20.0.orig/newlib/libc/include/stdio.h	2010-02-26 10:41:43.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/stdio.h	2012-03-28 10:11:12.255138622 +0200
@@ -308,7 +308,7 @@
  * Routines in POSIX 1003.1:2001.
  */
 
-#ifndef __STRICT_ANSI__
+#if (!defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L))
 #ifndef _REENT_ONLY
 FILE *	_EXFUN(fdopen, (int, const char *));
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/include/stdlib.h newlib-1.20.0/newlib/libc/include/stdlib.h
--- newlib-1.20.0.orig/newlib/libc/include/stdlib.h	2010-07-19 20:21:11.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/stdlib.h	2012-03-28 10:11:12.256138638 +0200
@@ -38,7 +38,7 @@
   long rem; /* remainder */
 } ldiv_t;
 
-#ifndef __STRICT_ANSI__
+#if !defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L)
 typedef struct
 {
   long long int quot; /* quotient */
@@ -63,13 +63,12 @@
 int	_EXFUN(abs,(int));
 int	_EXFUN(atexit,(_VOID (*__func)(_VOID)));
 double	_EXFUN(atof,(const char *__nptr));
-#ifndef __STRICT_ANSI__
-float	_EXFUN(atoff,(const char *__nptr));
-#endif
 int	_EXFUN(atoi,(const char *__nptr));
-int	_EXFUN(_atoi_r,(struct _reent *, const char *__nptr));
 long	_EXFUN(atol,(const char *__nptr));
+#ifndef __STRICT_ANSI__
+int	_EXFUN(_atoi_r,(struct _reent *, const char *__nptr));
 long	_EXFUN(_atol_r,(struct _reent *, const char *__nptr));
+#endif /* ! __STRICT_ANSI__ */
 _PTR	_EXFUN(bsearch,(const _PTR __key,
 		       const _PTR __base,
 		       size_t __nmemb,
@@ -80,10 +79,10 @@
 _VOID	_EXFUN(exit,(int __status) _ATTRIBUTE ((noreturn)));
 _VOID	_EXFUN_NOTHROW(free,(_PTR));
 char *  _EXFUN(getenv,(const char *__string));
+#ifndef __STRICT_ANSI__
 char *	_EXFUN(_getenv_r,(struct _reent *, const char *__string));
 char *	_EXFUN(_findenv,(_CONST char *, int *));
 char *	_EXFUN(_findenv_r,(struct _reent *, _CONST char *, int *));
-#ifndef __STRICT_ANSI__
 extern char *suboptarg;			/* getsubopt(3) external variable */
 int	_EXFUN(getsubopt,(char **, char * const *, char **));
 #endif
@@ -91,16 +90,16 @@
 ldiv_t	_EXFUN(ldiv,(long __numer, long __denom));
 _PTR	_EXFUN_NOTHROW(malloc,(size_t __size));
 int	_EXFUN(mblen,(const char *, size_t));
-int	_EXFUN(_mblen_r,(struct _reent *, const char *, size_t, _mbstate_t *));
 int	_EXFUN(mbtowc,(wchar_t *, const char *, size_t));
-int	_EXFUN(_mbtowc_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
 int	_EXFUN(wctomb,(char *, wchar_t));
-int	_EXFUN(_wctomb_r,(struct _reent *, char *, wchar_t, _mbstate_t *));
 size_t	_EXFUN(mbstowcs,(wchar_t *, const char *, size_t));
-size_t	_EXFUN(_mbstowcs_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
 size_t	_EXFUN(wcstombs,(char *, const wchar_t *, size_t));
-size_t	_EXFUN(_wcstombs_r,(struct _reent *, char *, const wchar_t *, size_t, _mbstate_t *));
 #ifndef __STRICT_ANSI__
+int	_EXFUN(_mblen_r,(struct _reent *, const char *, size_t, _mbstate_t *));
+int	_EXFUN(_mbtowc_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
+int	_EXFUN(_wctomb_r,(struct _reent *, char *, wchar_t, _mbstate_t *));
+size_t	_EXFUN(_mbstowcs_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
+size_t	_EXFUN(_wcstombs_r,(struct _reent *, char *, const wchar_t *, size_t, _mbstate_t *));
 #ifndef _REENT_ONLY
 char *	_EXFUN(mkdtemp,(char *));
 int	_EXFUN(mkostemp,(char *, int));
@@ -133,10 +132,11 @@
 # endif
 #endif
 long	_EXFUN(strtol,(const char *__n, char **__end_PTR, int __base));
-long	_EXFUN(_strtol_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
 unsigned long _EXFUN(strtoul,(const char *__n, char **__end_PTR, int __base));
+#ifndef __STRICT_ANSI__
 unsigned long _EXFUN(_strtoul_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
-
+long	_EXFUN(_strtol_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
+#endif /* !__STRICT_ANSI__ */
 int	_EXFUN(system,(const char *__string));
 
 #ifndef __STRICT_ANSI__
@@ -163,33 +163,39 @@
 int	_EXFUN(rand_r,(unsigned *__seed));
 
 double _EXFUN(drand48,(_VOID));
-double _EXFUN(_drand48_r,(struct _reent *));
 double _EXFUN(erand48,(unsigned short [3]));
-double _EXFUN(_erand48_r,(struct _reent *, unsigned short [3]));
 long   _EXFUN(jrand48,(unsigned short [3]));
-long   _EXFUN(_jrand48_r,(struct _reent *, unsigned short [3]));
 _VOID  _EXFUN(lcong48,(unsigned short [7]));
-_VOID  _EXFUN(_lcong48_r,(struct _reent *, unsigned short [7]));
 long   _EXFUN(lrand48,(_VOID));
-long   _EXFUN(_lrand48_r,(struct _reent *));
 long   _EXFUN(mrand48,(_VOID));
-long   _EXFUN(_mrand48_r,(struct _reent *));
 long   _EXFUN(nrand48,(unsigned short [3]));
-long   _EXFUN(_nrand48_r,(struct _reent *, unsigned short [3]));
 unsigned short *
        _EXFUN(seed48,(unsigned short [3]));
+_VOID  _EXFUN(srand48,(long));
+long long _EXFUN(atoll,(const char *__nptr));
+#ifndef __STRICT_ANSI__
+double _EXFUN(_drand48_r,(struct _reent *));
+double _EXFUN(_erand48_r,(struct _reent *, unsigned short [3]));
+long   _EXFUN(_jrand48_r,(struct _reent *, unsigned short [3]));
+_VOID  _EXFUN(_lcong48_r,(struct _reent *, unsigned short [7]));
+long   _EXFUN(_lrand48_r,(struct _reent *));
+long   _EXFUN(_mrand48_r,(struct _reent *));
+long   _EXFUN(_nrand48_r,(struct _reent *, unsigned short [3]));
 unsigned short *
        _EXFUN(_seed48_r,(struct _reent *, unsigned short [3]));
-_VOID  _EXFUN(srand48,(long));
 _VOID  _EXFUN(_srand48_r,(struct _reent *, long));
-long long _EXFUN(atoll,(const char *__nptr));
 long long _EXFUN(_atoll_r,(struct _reent *, const char *__nptr));
+#endif /* ! __STRICT_ANSI__ */
+#if !defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L)
 long long _EXFUN(llabs,(long long));
 lldiv_t	_EXFUN(lldiv,(long long __numer, long long __denom));
 long long _EXFUN(strtoll,(const char *__n, char **__end_PTR, int __base));
-long long _EXFUN(_strtoll_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
 unsigned long long _EXFUN(strtoull,(const char *__n, char **__end_PTR, int __base));
+#endif
+#ifndef __STRICT_ANSI__
+long long _EXFUN(_strtoll_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
 unsigned long long _EXFUN(_strtoull_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
+#endif /* ! __STRICT_ANSI__ */
 
 #ifndef __CYGWIN__
 _VOID	_EXFUN(cfree,(_PTR));
@@ -203,6 +209,7 @@
 
 #endif /* ! __STRICT_ANSI__ */
 
+#ifndef __STRICT_ANSI__
 char *	_EXFUN(_dtoa_r,(struct _reent *, double, int, int, int *, int*, char**));
 #ifndef __CYGWIN__
 _PTR	_EXFUN_NOTHROW(_malloc_r,(struct _reent *, size_t));
@@ -214,6 +221,7 @@
 int	_EXFUN(_system_r,(struct _reent *, const char *));
 
 _VOID	_EXFUN(__eprintf,(const char *, const char *, unsigned int, const char *));
+#endif /* ! __STRICT_ANSI__ */
 
 /* On platforms where long double equals double.  */
 #ifdef _LDBL_EQ_DBL
diff -Naur newlib-1.20.0.orig/newlib/libc/include/string.h newlib-1.20.0/newlib/libc/include/string.h
--- newlib-1.20.0.orig/newlib/libc/include/string.h	2011-06-10 20:30:38.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/string.h	2012-03-28 10:11:12.256138638 +0200
@@ -50,18 +50,11 @@
 #ifndef __STRICT_ANSI__
 char 	*_EXFUN(strtok_r,(char *, const char *, char **));
 
-int	 _EXFUN(bcmp,(const void *, const void *, size_t));
-void	 _EXFUN(bcopy,(const void *, void *, size_t));
-void	 _EXFUN(bzero,(void *, size_t));
-int	 _EXFUN(ffs,(int));
-char 	*_EXFUN(index,(const char *, int));
 _PTR	 _EXFUN(memccpy,(_PTR, const _PTR, int, size_t));
 _PTR	 _EXFUN(mempcpy,(_PTR, const _PTR, size_t));
 _PTR	 _EXFUN(memmem, (const _PTR, size_t, const _PTR, size_t));
-char 	*_EXFUN(rindex,(const char *, int));
 char 	*_EXFUN(stpcpy,(char *, const char *));
 char 	*_EXFUN(stpncpy,(char *, const char *, size_t));
-int	 _EXFUN(strcasecmp,(const char *, const char *));
 char	*_EXFUN(strcasestr,(const char *, const char *));
 char 	*_EXFUN(strchrnul,(const char *, int));
 char 	*_EXFUN(strdup,(const char *));
@@ -84,14 +77,11 @@
 #endif
 size_t	 _EXFUN(strlcat,(char *, const char *, size_t));
 size_t	 _EXFUN(strlcpy,(char *, const char *, size_t));
-int	 _EXFUN(strncasecmp,(const char *, const char *, size_t));
 size_t	 _EXFUN(strnlen,(const char *, size_t));
 char 	*_EXFUN(strsep,(char **, const char *));
 char	*_EXFUN(strlwr,(char *));
 char	*_EXFUN(strupr,(char *));
-#ifndef DEFS_H	/* Kludge to work around problem compiling in gdb */
-char  *_EXFUN(strsignal, (int __signo));
-#endif
+char	*_EXFUN(strsignal, (int __signo));
 #ifdef __CYGWIN__
 int     _EXFUN(strtosigno, (const char *__name));
 #endif
@@ -113,20 +103,6 @@
 			 (char *) memcpy (__out, __in, __len-1);}))
 #endif /* _GNU_SOURCE && __GNUC__ */
 
-/* These function names are used on Windows and perhaps other systems.  */
-#ifndef strcmpi
-#define strcmpi strcasecmp
-#endif
-#ifndef stricmp
-#define stricmp strcasecmp
-#endif
-#ifndef strncmpi
-#define strncmpi strncasecmp
-#endif
-#ifndef strnicmp
-#define strnicmp strncasecmp
-#endif
-
 #endif /* ! __STRICT_ANSI__ */
 
 #include <sys/string.h>
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/_default_fcntl.h newlib-1.20.0/newlib/libc/include/sys/_default_fcntl.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/_default_fcntl.h	2010-01-14 19:49:13.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/sys/_default_fcntl.h	2012-03-28 10:11:12.256138638 +0200
@@ -51,8 +51,6 @@
 #define O_BINARY	_FBINARY
 #define O_TEXT		_FTEXT
 #define O_NOINHERIT	_FNOINHERIT
-/* O_CLOEXEC is the Linux equivalent to O_NOINHERIT */
-#define O_CLOEXEC	_FNOINHERIT
 
 /* The windows header files define versions with a leading underscore.  */
 #define _O_RDONLY	O_RDONLY
@@ -124,9 +122,6 @@
 #define	F_CNVT 		12	/* Convert a fhandle to an open fd */
 #define	F_RSETLKW 	13	/* Set or Clear remote record-lock(Blocking) */
 #endif	/* !_POSIX_SOURCE */
-#ifdef __CYGWIN__
-#define	F_DUPFD_CLOEXEC	14	/* As F_DUPFD, but set close-on-exec flag */
-#endif
 
 /* fcntl(2) flags (l_type field of flock structure) */
 #define	F_RDLCK		1	/* read lock */
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/resource.h newlib-1.20.0/newlib/libc/include/sys/resource.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/resource.h	2000-02-17 20:39:46.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/sys/resource.h	2012-03-28 10:11:12.257138654 +0200
@@ -6,10 +6,22 @@
 #define	RUSAGE_SELF	0		/* calling process */
 #define	RUSAGE_CHILDREN	-1		/* terminated child processes */
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
 struct rusage {
   	struct timeval ru_utime;	/* user time used */
 	struct timeval ru_stime;	/* system time used */
 };
 
+#if defined(__rtems__)
+int _EXFUN(getrusage,(int who, struct rusage *usage));
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/time.h newlib-1.20.0/newlib/libc/include/sys/time.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/time.h	2009-10-09 20:43:12.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/sys/time.h	2012-03-28 10:11:12.257138654 +0200
@@ -78,6 +78,11 @@
 int _EXFUN(setitimer, (int __which, const struct itimerval *__value,
 					struct itimerval *__ovalue));
 
+#if defined(__rtems__)
+/* BSD function used by RTEMS code */
+int _EXFUN(adjtime,(const struct timeval *, struct timeval *));
+#endif
+
 #ifdef __cplusplus
 }
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/unistd.h newlib-1.20.0/newlib/libc/include/sys/unistd.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/unistd.h	2011-08-19 16:29:34.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/sys/unistd.h	2012-03-28 10:11:12.258138670 +0200
@@ -71,6 +71,9 @@
 long    _EXFUN(fpathconf, (int __fd, int __name ));
 int     _EXFUN(fsync, (int __fd));
 int     _EXFUN(fdatasync, (int __fd));
+#if defined(__CYGWIN__)
+char *  _EXFUN(get_current_dir_name, (void));
+#endif
 char *  _EXFUN(getcwd, (char *__buf, size_t __size ));
 #if defined(__CYGWIN__)
 int	_EXFUN(getdomainname ,(char *__name, size_t __len));
diff -Naur newlib-1.20.0.orig/newlib/libc/include/tgmath.h newlib-1.20.0/newlib/libc/include/tgmath.h
--- newlib-1.20.0.orig/newlib/libc/include/tgmath.h	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/tgmath.h	2012-03-28 10:11:12.259138686 +0200
@@ -0,0 +1,185 @@
+/* http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/tgmath.h.html */
+/*-
+ * Copyright (c) 2004 Stefan Farfeleder.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD$
+ */
+
+#ifndef _TGMATH_H_
+#define	_TGMATH_H_
+
+#include <complex.h>
+#include <math.h>
+
+#ifdef log2
+#undef log2
+#endif
+
+/*
+ * This implementation of <tgmath.h> requires two implementation-dependent
+ * macros to be defined:
+ * __tg_impl_simple(x, y, z, fn, fnf, fnl, ...)
+ *	Invokes fnl() if the corresponding real type of x, y or z is long
+ *	double, fn() if it is double or any has an integer type, and fnf()
+ *	otherwise.
+ * __tg_impl_full(x, y, z, fn, fnf, fnl, cfn, cfnf, cfnl, ...)
+ *	Invokes [c]fnl() if the corresponding real type of x, y or z is long
+ *	double, [c]fn() if it is double or any has an integer type, and
+ *	[c]fnf() otherwise.  The function with the 'c' prefix is called if
+ *	any of x, y or z is a complex number.
+ * Both macros call the chosen function with all additional arguments passed
+ * to them, as given by __VA_ARGS__.
+ *
+ * Note that these macros cannot be implemented with C's ?: operator,
+ * because the return type of the whole expression would incorrectly be long
+ * double complex regardless of the argument types.
+ */
+
+/* requires GCC >= 3.1 */
+#if !defined(__GNUC__) || __GNUC__ < 3 || \
+	(__GNUC__ == 3 && __GNUC_MINOR__ < 1)
+#error "<tgmath.h> not implemented for this compiler"
+#endif
+
+#define	__tg_type(__e, __t)						\
+	__builtin_types_compatible_p(__typeof__(__e), __t)
+#define	__tg_type3(__e1, __e2, __e3, __t)				\
+	(__tg_type(__e1, __t) || __tg_type(__e2, __t) || 		\
+	 __tg_type(__e3, __t))
+#define	__tg_type_corr(__e1, __e2, __e3, __t)				\
+	(__tg_type3(__e1, __e2, __e3, __t) || 				\
+	 __tg_type3(__e1, __e2, __e3, __t _Complex))
+#define	__tg_integer(__e1, __e2, __e3)					\
+	(((__typeof__(__e1))1.5 == 1) || ((__typeof__(__e2))1.5 == 1) ||	\
+	 ((__typeof__(__e3))1.5 == 1))
+#define	__tg_is_complex(__e1, __e2, __e3)				\
+	(__tg_type3(__e1, __e2, __e3, float _Complex) ||		\
+	 __tg_type3(__e1, __e2, __e3, double _Complex) ||		\
+	 __tg_type3(__e1, __e2, __e3, long double _Complex) ||		\
+	 __tg_type3(__e1, __e2, __e3, __typeof__(_Complex_I)))
+
+#ifdef _LDBL_EQ_DBL
+#define	__tg_impl_simple(x, y, z, fn, fnf, fnl, ...)			\
+	__builtin_choose_expr(__tg_type_corr(x, y, z, long double),	\
+	    fnl(__VA_ARGS__), __builtin_choose_expr(			\
+		__tg_type_corr(x, y, z, double) || __tg_integer(x, y, z),\
+		fn(__VA_ARGS__), fnf(__VA_ARGS__)))
+#else
+#define	__tg_impl_simple(__x, __y, __z, __fn, __fnf, __fnl, ...)	\
+	(__tg_type_corr(__x, __y, __z, double) || __tg_integer(__x, __y, __z)) \
+		? __fn(__VA_ARGS__) : __fnf(__VA_ARGS__)
+#endif
+
+#define	__tg_impl_full(__x, __y, __z, __fn, __fnf, __fnl, __cfn, __cfnf, __cfnl, ...)	\
+	__builtin_choose_expr(__tg_is_complex(__x, __y, __z),		\
+	    __tg_impl_simple(__x, __y, __z, __cfn, __cfnf, __cfnl, __VA_ARGS__),	\
+	    __tg_impl_simple(__x, __y, __z, __fn, __fnf, __fnl, __VA_ARGS__))
+
+/* Macros to save lots of repetition below */
+#define	__tg_simple(__x, __fn)						\
+	__tg_impl_simple(__x, __x, __x, __fn, __fn##f, __fn##l, __x)
+#define	__tg_simple2(__x, __y, __fn)					\
+	__tg_impl_simple(__x, __x, __y, __fn, __fn##f, __fn##l, __x, __y)
+#define	__tg_simplev(__x, __fn, ...)					\
+	__tg_impl_simple(__x, __x, __x, __fn, __fn##f, __fn##l, __VA_ARGS__)
+#define	__tg_full(__x, __fn)						\
+	__tg_impl_full(__x, __x, __x, __fn, __fn##f, __fn##l, c##__fn, c##__fn##f, c##__fn##l, __x)
+
+/* 7.22#4 -- These macros expand to real or complex functions, depending on
+ * the type of their arguments. */
+#define	acos(__x)		__tg_full(__x, acos)
+#define	asin(__x)		__tg_full(__x, asin)
+#define	atan(__x)		__tg_full(__x, atan)
+#define	acosh(__x)		__tg_full(__x, acosh)
+#define	asinh(__x)		__tg_full(__x, asinh)
+#define	atanh(__x)		__tg_full(__x, atanh)
+#define	cos(__x)		__tg_full(__x, cos)
+#define	sin(__x)		__tg_full(__x, sin)
+#define	tan(__x)		__tg_full(__x, tan)
+#define	cosh(__x)		__tg_full(__x, cosh)
+#define	sinh(__x)		__tg_full(__x, sinh)
+#define	tanh(__x)		__tg_full(__x, tanh)
+#define	exp(__x)		__tg_full(__x, exp)
+#define	log(__x)		__tg_full(__x, log)
+#define	pow(__x, __y)		__tg_impl_full(__x, __x, __y, pow, powf, powl,	\
+						cpow, cpowf, cpowl, __x, __y)
+#define	sqrt(__x)		__tg_full(__x, sqrt)
+
+/* "The corresponding type-generic macro for fabs and cabs is fabs." */
+#define	fabs(__x)		__tg_impl_full(__x, __x, __x, fabs, fabsf, fabsl,	\
+						cabs, cabsf, cabsl, __x)
+
+/* 7.22#5 -- These macros are only defined for arguments with real type. */
+#define	atan2(__x, __y)		__tg_simple2(__x, __y, atan2)
+#define	cbrt(__x)		__tg_simple(__x, cbrt)
+#define	ceil(__x)		__tg_simple(__x, ceil)
+#define	copysign(__x, __y)	__tg_simple2(__x, __y, copysign)
+#define	erf(__x)		__tg_simple(__x, erf)
+#define	erfc(__x)		__tg_simple(__x, erfc)
+#define	exp2(__x)		__tg_simple(__x, exp2)
+#define	expm1(__x)		__tg_simple(__x, expm1)
+#define	fdim(__x, __y)		__tg_simple2(__x, __y, fdim)
+#define	floor(__x)		__tg_simple(__x, floor)
+#define	fma(__x, __y, __z)	__tg_impl_simple(__x, __y, __z, fma, fmaf, fmal, \
+						 __x, __y, __z)
+#define	fmax(__x, __y)		__tg_simple2(__x, __y, fmax)
+#define	fmin(__x, __y)		__tg_simple2(__x, __y, fmin)
+#define	fmod(__x, __y)		__tg_simple2(__x, __y, fmod)
+#define	frexp(__x, __y)		__tg_simplev(__x, frexp, __x, __y)
+#define	hypot(__x, __y)		__tg_simple2(__x, __y, hypot)
+#define	ilogb(__x)		__tg_simple(__x, ilogb)
+#define	ldexp(__x, __y)		__tg_simplev(__x, ldexp, __x, __y)
+#define	lgamma(__x)		__tg_simple(__x, lgamma)
+#define	llrint(__x)		__tg_simple(__x, llrint)
+#define	llround(__x)		__tg_simple(__x, llround)
+#define	log10(__x)		__tg_simple(__x, log10)
+#define	log1p(__x)		__tg_simple(__x, log1p)
+#define	log2(__x)		__tg_simple(__x, log2)
+#define	logb(__x)		__tg_simple(__x, logb)
+#define	lrint(__x)		__tg_simple(__x, lrint)
+#define	lround(__x)		__tg_simple(__x, lround)
+#define	nearbyint(__x)		__tg_simple(__x, nearbyint)
+#define	nextafter(__x, __y)	__tg_simple2(__x, __y, nextafter)
+/* not yet implemented even for _LDBL_EQ_DBL platforms
+#define	nexttoward(__x, __y)	__tg_simplev(__x, nexttoward, __x, __y)
+*/
+#define	remainder(__x, __y)	__tg_simple2(__x, __y, remainder)
+#define	remquo(__x, __y, __z)	__tg_impl_simple(__x, __x, __y, remquo, remquof,	\
+						 remquol, __x, __y, __z)
+#define	rint(__x)		__tg_simple(__x, rint)
+#define	round(__x)		__tg_simple(__x, round)
+#define	scalbn(__x, __y)	__tg_simplev(__x, scalbn, __x, __y)
+#define	scalbln(__x, __y)	__tg_simplev(__x, scalbln, __x, __y)
+#define	tgamma(__x)		__tg_simple(__x, tgamma)
+#define	trunc(__x)		__tg_simple(__x, trunc)
+
+/* 7.22#6 -- These macros always expand to complex functions. */
+#define	carg(__x)		__tg_simple(__x, carg)
+#define	cimag(__x)		__tg_simple(__x, cimag)
+#define	conj(__x)		__tg_simple(__x, conj)
+#define	cproj(__x)		__tg_simple(__x, cproj)
+#define	creal(__x)		__tg_simple(__x, creal)
+
+#endif /* !_TGMATH_H_ */
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/access.c newlib-1.20.0/newlib/libc/machine/arm/access.c
--- newlib-1.20.0.orig/newlib/libc/machine/arm/access.c	2004-06-09 21:05:09.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/access.c	2012-03-28 10:11:12.260138701 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/arm_asm.h newlib-1.20.0/newlib/libc/machine/arm/arm_asm.h
--- newlib-1.20.0.orig/newlib/libc/machine/arm/arm_asm.h	2011-10-18 13:35:17.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/arm_asm.h	2012-03-28 10:11:12.260138701 +0200
@@ -62,22 +62,7 @@
 
 
 /* Now some macros for common instruction sequences.  */
-#ifdef __ASSEMBLER__
-.macro  RETURN     cond=
-#if defined (_ISA_ARM_4T) || defined (_ISA_THUMB_1)
-	bx\cond	lr
-#else
-	mov\cond pc, lr
-#endif
-.endm
-
-.macro optpld	base, offset=#0
-#if defined (_ISA_ARM_7)
-	pld	[\base, \offset]
-#endif
-.endm
 
-#else
 asm(".macro  RETURN	cond=\n\t"
 #if defined (_ISA_ARM_4T) || defined (_ISA_THUMB_1)
     "bx\\cond	lr\n\t"
@@ -93,6 +78,5 @@
 #endif
     ".endm"
     );
-#endif
 
 #endif /* ARM_ASM__H */
